<template>
  <div>
    <month-line :date="date" />
    <div :class="$style.breakline"></div>
    <div :class="$style.transactions_list">
      <span v-show="isLoading">Loading...</span>
      <day-stats
          v-for="({transactions, date}, day) in transactionsByDay"
          :key="day"
          :date="date"
          :transactions="transactions"
      />
    </div>
  </div>
</template>

<style module>
.breakline {
  height: 1px;
  background: #e7e7e7;
  width: 108%;
  position: relative;
  right: 4%;
}
.transactions_list {
  height: 450px;
  overflow-x: scroll;
}
/* width */
::-webkit-scrollbar {
  width: 20px;
}

/* Track */
::-webkit-scrollbar-track {
  box-shadow: inset 0 0 5px grey;
  border-radius: 10px;
}

/* Handle */
::-webkit-scrollbar-thumb {
  background: red;
  border-radius: 10px;
}
</style>

<script>
import moment from 'moment';
import MonthLine from './MonthLine';
import TransactionItem from './TransactionItem';
import DayStats from './DayStats';

export default {
  components: {
    MonthLine,
    TransactionItem,
    DayStats,
  },
  data() {
    return {
      isLoading: true,
      transactions: [],
    };
  },
  computed: {
    date() {
      return moment().locale('ru');
    },
    transactionsByDay() {
      return this.transactions.reduce((accum, transaction) => {
        const day = moment(transaction.created_at).date();
        if (!accum[day]) {
          accum[day] = {
            date: moment(transaction.created_at).toDate().toDateString(),
            transactions: [],
          };
        }
        accum[day].transactions.push(transaction);
        return accum;
      }, {});
    },
  },
  mounted() {
    this.fetchTransactions();
  },
  methods: {
    fetchTransactions() {
      axios.get('/api/transactions')
        .then(response => {
          this.transactions = response.data.data;
        })
        .catch(error => {
          console.error(error);
        })
        .finally(() => {
          this.isLoading = false;
        })
    },
  },
};
</script>